// Program : Timer test (Compilar con B.Bat : B TstTimer)
// Author  : Arteaga

#Include "Fivewin.Ch"

#Define GRAPH_TYPE_BAR   1
#Define GRAPH_TYPE_LINE  2

Static oWnd, oGraph, oTimer, aVals, nP

FUNCTION Main()

   LOCAL oReg, oIcon

   nP:=19
   aVals:=Array(20)
   Afill(aVals,0)

   DEFINE WINDOW oWnd TITLE "TGraph, timer test" FROM 0, 0 TO 8,40
   oGraph:=TGraph():New(0,0,oWnd,oWnd:nWidth()-8,oWnd:nHeight()-40)

   oGraph:cPicture := "999"
   oGraph:l3D      := .F.
   oGraph:aYVals   := {}
   oGraph:lDotted  := .F.
   oGraph:lLegends := .F.
   oGraph:lTitle   := .F.
   oGraph:lPopUp   := .T.
   oGraph:nPenWidth:= 1
   oGraph:nClrBack := CLR_BLACK
   oGraph:nClrGrid := CLR_GREEN
   oGraph:nType    := GRAPH_TYPE_LINE

   aVals[19] :=  15
   aVals[20] := 150

   oGraph:AddSerie(aVals, "", RGB(255, 255, 0))

   Define Timer oTimer Interval 900 Action Update() OF oWnd
   Activate Timer oTimer

   WndCenter(oWnd:hWnd)

   ACTIVATE WINDOW oWnd                          ;
      ON PAINT (oGraph:nWidth:=oWnd:nWidth()- 8, ;
                oGraph:nHeight:=oWnd:nHeight-40, ;
                oGraph:Refresh(.f.))

   oTimer:End()

RETURN (NIL)

Function Update(oReg)
  LOCAL aTmp :={150, 15,135, 30,120, 45,105, 60, 90, 75,;
                 75, 90, 60,105, 45,120, 30,135, 15,150 }
  LOCAL aTemp[20]
  nP--
  nP:=IF(nP=0,20,nP)
  ACopy(aVals,aTemp,2)
  aTemp[20]:=aTmp[nP]
  aVals:=AClone(aTemp)
  SysRefresh()
  oGraph:aData[1]:=aVals
  oGraph:Refresh()
RETURN (NIL)
